<?php
try{
    if(!class_exists('trustami_product_api')){
        require_once $oPlugin->cFrontendPfad.'../class/trustami_product_api.php';
    }
}
catch(Exception $e){
    echo 'Exception caught while importing trustami API class: ',  $e->getMessage(), "\n";
}
$apiUserName = $oPlugin->oPluginEinstellungAssoc_arr['apiUserName'];
$apiKey = $oPlugin->oPluginEinstellungAssoc_arr['apiKey'];

if (strlen($apiKey) && strlen($apiUserName)){
    $view = NULL;
    $gtinItems = array();
    $tempProdArray = array();
    $feContainer = "body";
    $apiCred = $apiUserName.":".$apiKey;

    $smarty->assign("cusPageBox", $oPlugin->oPluginEinstellungAssoc_arr['customProdStartPageBox']);
    $smarty->assign("cusSearchBox", $oPlugin->oPluginEinstellungAssoc_arr['customProdCatSearchBox']);
    $smarty->assign("cusCartBox", $oPlugin->oPluginEinstellungAssoc_arr['customProdCartBox']);
    $smarty->assign("cusStarsColor", $oPlugin->oPluginEinstellungAssoc_arr['customProdStarsColor']);

    if (!empty($oPlugin->oPluginEinstellungAssoc_arr['customDataAttr'])) {
        $smarty->assign("cusDataAttr", urlencode($oPlugin->oPluginEinstellungAssoc_arr['customDataAttr']));
        $dataAttr = [];
        $parsedJsonAttr = json_decode($oPlugin->oPluginEinstellungAssoc_arr['customDataAttr']);
        foreach($parsedJsonAttr as $key => $value) {
          $dataAttr[] = $key.'="'.$value.'"';
        }
        $smarty->assign('dataAttr', implode(" ",$dataAttr));
    }

    $prodStartPgBox = $oPlugin->oPluginEinstellungAssoc_arr['prodStartPageBox'];
    $prodCatSearchBox = $oPlugin->oPluginEinstellungAssoc_arr['prodCatSearchBox'];
    $prodViewTtlBox = $oPlugin->oPluginEinstellungAssoc_arr['prodViewTtlBox'];
    $prodViewRtgBox = $oPlugin->oPluginEinstellungAssoc_arr['prodViewRtgBox'];
    $prodCartBox = $oPlugin->oPluginEinstellungAssoc_arr['prodCartBox'];
    $prodOrderStepBox = $oPlugin->oPluginEinstellungAssoc_arr['prodOrderStepBox'];
    $prodCmpBox = $oPlugin->oPluginEinstellungAssoc_arr['prodCmpBox'];
    $prodWishBox = $oPlugin->oPluginEinstellungAssoc_arr['prodWishBox'];
    $cusRtgTtlBox = $oPlugin->oPluginEinstellungAssoc_arr['customProdViewTtlBox'];
    $cusRtgViewBox = $oPlugin->oPluginEinstellungAssoc_arr['customProdViewRtgBox'];

    $GLOBALS["productGenOption"] = $oPlugin->oPluginEinstellungAssoc_arr['prodRtgGenOption'];
    $GLOBALS["prodShopRtgCnt"] = $oPlugin->oPluginEinstellungAssoc_arr['prodShopRtgCnt'];

    $currentProductView = $smarty->get_template_vars('Artikel');
    $productCart = $smarty->get_template_vars('Warenkorb')->PositionenArr;

    function getGtinFromArtikel($filteredItem){
        $gtinsStr = NULL;  
        try { 
            $tmpGtins = $filteredItem->FunktionsAttribute;
            if (isset($tmpGtins) && !empty($tmpGtins["gtin"])){
                $gtinsStr = join(' ,', preg_split("(\n|\s)",trim($tmpGtins["gtin"])));
            }
            if ($GLOBALS["productGenOption"] === "1" && !empty($filteredItem->cBarcode)){
                if (!empty($gtinsStr)){
                    $gtinsStr = $filteredItem->cBarcode.", ".$gtinsStr;
                }else{
                    $gtinsStr = $filteredItem->cBarcode;
                }
            }
        } catch (Exception $e) { 
            return NULL;
        }
        return $gtinsStr;
    }

    function assignScriptParam($filteredItem){
        if (isset($filteredItem->kVaterArtikel) && $filteredItem->kVaterArtikel != $filteredItem->kArtikel){
            $filteredItem->fuelleArtikel($filteredItem->kVaterArtikel, $filteredItem->getDetailOptions());
        }

        if ($filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl > 0){
            return 'data-ort="'.$filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl.'" data-ors="'.$filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->fDurchschnitt.'"';
        }
        return NULL;
    }

    function buildGtinObjects($filteredItems, $view = NULL){
        if(!isset($view)) {
            $view = "slider";
        }
        $gtinItems = array();
        foreach ($filteredItems as $filteredItem) {
            $data = array();
            $data["view"] = $view;
            $data["gtin"] = getGtinFromArtikel($filteredItem);
            
            if (isset($data["gtin"]) && $GLOBALS["prodShopRtgCnt"] === "1"){
                if (isset($filteredItem->kVaterArtikel) && $filteredItem->kVaterArtikel != $filteredItem->kArtikel){
                    $filteredItem->fuelleArtikel($filteredItem->kVaterArtikel, $filteredItem->getDetailOptions());
                }

                if ($filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl > 0){
                    $data["rtgTtl"] = $filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl;
                    $data['rtgScr'] = $filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->fDurchschnitt;
                }

            }
            array_push($gtinItems, $data);
        }
        return $gtinItems;
    }

    function buildApiPostObjects($gtinItems){
        $apiPostItems = array();
        foreach ($gtinItems as $indx => $slItemVal){
            if ($feContainer == "#cart-form" && $slItemVal['view'] == "slider"){
                if (!isset($cartIndex)){
                    $cartIndex = 0;
                }
                $indx = $cartIndex;
                $cartIndex += 1;
            }
            else if ($slItemVal['view'] == "product"){
                $indx -= 1;
            }
            $postArg =array();
            $postArg['key'] = $slItemVal['view']."_".($indx);
            $postArg['gtin'] = $slItemVal['gtin'];
            if (isset($slItemVal["rtgTtl"]) && $slItemVal["rtgTtl"] > 0){
                $postArg["ort"] = $slItemVal["rtgTtl"];
                $postArg['ors'] = $slItemVal["rtgScr"];
            }
            array_push($apiPostItems, $postArg);
        }
        return $apiPostItems;
    }
    
    try{

        if ($prodStartPgBox === "1" || $prodCatSearchBox === "1"){
            $filteredItems = array();
            $sliderProdArray = $smarty->get_template_vars('StartseiteBoxen');
            $catProdArr = $smarty->get_template_vars('KategorieInhalt');
            $searchProdResArray = $smarty->get_template_vars('Suchergebnisse');

            if (isset($sliderProdArray) && $prodStartPgBox === "1"){
                $tempProdArray = array_merge($tempProdArray, $sliderProdArray);
            }
            
            if (isset($catProdArr) && $prodCatSearchBox === "1"){
                array_push($tempProdArray, $catProdArr);
            }

            if (isset($searchProdResArray) && $prodCatSearchBox === "1"){
                array_push($tempProdArray, $searchProdResArray);
                $feContainer = "#result-wrapper";
                if (gibSeitenTyp() == 2){
                    $smarty->assign('taIsSearchRes', 1);
                }
                $view = "search";
            }
            if (!empty($tempProdArray)){
                foreach ($tempProdArray as $classElement) {
                    if (isset($classElement->Artikel)){
                        $filteredItems = array_merge($filteredItems, $classElement->Artikel->elemente);
                    }      
                    if (isset($classElement->TopArtikel)){
                        $filteredItems = array_merge($filteredItems, $classElement->TopArtikel->elemente);
                    }  
                    if (isset($classElement->BestsellerArtikel)){
                        $filteredItems = array_merge($filteredItems, $classElement->BestsellerArtikel->elemente);
                    }
                }
                $gtinItems = buildGtinObjects($filteredItems, $view);
            }
        }
        $trustamiProductScript = $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_product_script.tpl');
        
        if (($prodCartBox === "1" && isset($productCart)) || ($prodOrderStepBox === "1" && !empty(pq('#complete_order')->elements) && isset($_SESSION['Warenkorb']->PositionenArr))){
            $feContainer = "#cart-form";
            if (!isset($productCart)){
                $productCart = $_SESSION['Warenkorb']->PositionenArr;
                $feContainer = "#complete_order";
            }

            foreach ($productCart as $cprod){
                if(isset($cprod->Artikel)){
                    array_push($filteredItems, $cprod->Artikel);
                }
            }
            $gtinItems = buildGtinObjects($filteredItems, "cart");
            
            $boughtTogetherProdCart = $smarty->get_template_vars('xselling')->Kauf->Artikel;
            if (isset($boughtTogetherProdCart)){
                $filteredItems = array();
                foreach ($boughtTogetherProdCart as $btgprod){
                    array_push($filteredItems, $btgprod);
                }
                $gtinItems = array_merge($gtinItems, buildGtinObjects($filteredItems));
            }
        }

        if (($prodViewTtlBox !== "0" || $prodViewRtgBox !== "0") && isset($currentProductView)){
            $smarty->assign('cardId', $apiUserName);
            $currentProdGtin = getGtinFromArtikel($currentProductView);
            if (isset($currentProdGtin)){
                $taCfg = [];
                $taModes = [];
                $curProd = array();
                $smarty->assign('currentProdGtin', $currentProdGtin);
                if ($prodViewRtgBox != "0"){
                    $taModes[] = $prodViewRtgBox;
                    $smarty->assign('prodViewRtgBox', $prodViewRtgBox);
                    if ($oPlugin->oPluginEinstellungAssoc_arr['custAdvCfg'] != "")
                        $taCfg[] = $oPlugin->oPluginEinstellungAssoc_arr['custAdvCfg'];
                }
                if ($prodViewTtlBox != "0"){
                    $smarty->assign('prodViewTtlBox', $prodViewTtlBox);
                    $taModes[] = $prodViewTtlBox;
                    if ($prodViewTtlBox == "3")
                        $taCfgCls = 2;
                    else
                        $taCfgCls = 1;
                    $taCfg[] = '"'.$prodViewTtlBox.'":{"linkAllowed":false, "css":"body{float:left;margin-right:0px!important;} .mini-widget-body-2 .mini_widget_icon{top: 0px;} .mini-number-1,.mini-number-2{font-family:sans-serif;}"}';
                }
                if ($taModes){
                    $smarty->assign('taModes', urlencode('['.implode(",", $taModes).']'));
                    $smarty->assign('taCfg', urlencode('{'.implode(",", $taCfg).'}'));
                }

                array_push($curProd, $currentProductView);
                $dataParam = assignScriptParam($curProd[0]);    
                if ($dataParam)
                    $smarty->assign('prodParam', $dataParam);  

                $gtinItems = buildGtinObjects($curProd, "current_product");   
                $trustamiProductView = $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_product_details.tpl');
                if (isset($cusRtgViewBox) && !empty($cusRtgViewBox)) {
                    pq($cusRtgViewBox)->append($trustamiProductView);
                } else {
                    pq('#reviews-overview>div')->eq(0)->prepend($trustamiProductView);
                }

                $trustamiProdWidget = $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_product_widget_script.tpl');
                $widgetContainer = pq("#result-wrapper");
                if (empty($widgetContainer->elements))
                    $widgetContainer = (pq("footer")->elements ? pq("footer") : pq("body"));
                $widgetContainer->append($trustamiProdWidget);
            }

            $prodBoughtTogether = $smarty->get_template_vars('Xselling');
            if (isset($prodBoughtTogether->Kauf->Artikel)){
                $tempProdArray = array_merge($tempProdArray, $prodBoughtTogether->Kauf->Artikel);
            }
            $prodSimilarProds = $smarty->get_template_vars('oAehnlicheArtikel_arr');
            if (isset($prodSimilarProds)){
                $tempProdArray = array_merge($tempProdArray, $prodSimilarProds);
            }
            if (isset($gtinItems)){
                $gtinItems = array_merge($gtinItems, buildGtinObjects($tempProdArray, "product"));
            }
            else{
                $gtinItems = buildGtinObjects($tempProdArray, "product");
            }
            $feContainer = "#result-wrapper";
        }

        if ((gibSeitenTyp() == 16 || gibSeitenTyp() == 4) && $prodWishBox === "1" && pq('form[name="Wunschliste"]')->elements && isset($_SESSION["Wunschliste"]->CWunschlistePos_arr)){
            $wish_list = array();
            foreach ($_SESSION["Wunschliste"]->CWunschlistePos_arr as $classElement) {
                if (isset($classElement->Artikel)){
                    array_push($wish_list, $classElement->Artikel);
                }  
            }
            if (!empty($wish_list)){
                $gtinItems = buildGtinObjects($wish_list, "wish");
                $feContainer = 'form[name="Wunschliste"]';
            }
        }

        if (gibSeitenTyp() == 17 && $prodCmpBox === "1" && pq(".comparelist")->elements && isset($_SESSION["Vergleichsliste"]->oArtikel_arr)){
            $cmp_list = array();
            foreach ($_SESSION["Vergleichsliste"]->oArtikel_arr as $classElement) {
                if (isset($classElement->kArtikel)){
                    $tmp_prod = new Artikel();
                    array_push($cmp_list, $tmp_prod->fuelleArtikel($classElement->kArtikel, $tmp_prod->getDetailOptions()));
                }  
            }
            if (!empty($cmp_list)){
                $gtinItems = buildGtinObjects($cmp_list, "compare");
                $feContainer = ".comparelist";
            }
        }

        if (is_array($gtinItems) && !empty($gtinItems)){
            $apiPostItems = buildApiPostObjects($gtinItems);
            if (!empty($apiPostItems)){
                $gtins = array();
                $gtins = ["params" => $apiPostItems];
                $taClient = new trustami_product_api($apiCred);
                $results = $taClient->post_multiple_products($gtins);
                if ($results){
                    $jsonResponse = json_decode($results);
                    if (isset($jsonResponse->code) && $jsonResponse->code == 200 && isset($jsonResponse->result)){
                        foreach ($jsonResponse->result as $taProductKey => $taProductObj){
                            $htmlIndex = explode('_', $taProductKey);
                            $htmlIndex = (string)end($htmlIndex);
                            
                            if (strpos($taProductKey, "cart") !== false){
                                if (!isset($cartJsonProducts)){
                                    $cartJsonProducts = array();
                                }
                                $cartJsonProducts[$htmlIndex] = $taProductObj->score;
                            }
                            else if (strpos($taProductKey, "compare") !== false || strpos($taProductKey, "wish") !== false){
                                if (!isset($cmpWishJsonProducts)){
                                    $cmpWishJsonProducts = array();
                                }
                                
                                $cmpWishJsonProducts[$htmlIndex] = $taProductObj->score;
                            }
                            else if (strpos($taProductKey, "current_product") !== false){
                                if($taProductObj->score->ratingsTotal>0){
                                    $smarty->assign('taProductTtl', $taProductObj->score->ratingsTotal_abbrev);
                                    if (!empty($oPlugin->oPluginEinstellungAssoc_arr['prodViewTtlClassBox']))
                                        $smarty->assign('prodTtlClass', ' '.$oPlugin->oPluginEinstellungAssoc_arr['prodViewTtlClassBox']);

                                    $trustamiProductMini = $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_product_mini.tpl');

                                    if (isset($cusRtgTtlBox) && !empty($cusRtgTtlBox)) {
                                        pq($cusRtgTtlBox)->append($trustamiProductMini);
                                    } else {
                                        pq('.info-essential')->append($trustamiProductMini);
                                    }
                                }
                            } 
                            else{
                                if (!isset($taProductList)){
                                    $taProductList = array();
                                }
                                $taProductList[$htmlIndex] = $taProductObj->score;
                            }
                        }
                        if (isset($cartJsonProducts) || isset($taProductList)){
                            if (isset($cartJsonProducts)){
                                $smarty->assign('taCartProductList', json_encode($cartJsonProducts));
                            }
                            if (isset($taProductList)){
                                $smarty->assign('taProductList', json_encode($taProductList));
                            }
                            pq($feContainer)->append($trustamiProductScript);

                            $trustamiHomePageScript = $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_products_list.tpl');
                            pq($feContainer)->append($trustamiHomePageScript);
                        }
                        else if (isset($cmpWishJsonProducts)){
                            $smarty->assign('taCmpWishList', json_encode($cmpWishJsonProducts));
                            if (!pq("#trustami-product-plugin")->elements){
                                pq($feContainer)->append($trustamiProductScript);
                            }
                            if ($feContainer == ".comparelist"){
                                $smarty->assign('taListContainer', 2);
                            } else if ($feContainer == 'form[name="Wunschliste"]'){
                                $smarty->assign('taListContainer', 3);
                            }

                            $trustamiCmpWishView= $smarty->fetch($oPlugin->cFrontendPfad . 'template/trustami_wish_cmp_list.tpl');
                            pq($feContainer)->append($trustamiCmpWishView); 
                        }
                    }
                }
            }
        }
    }catch(Exception $e){
        echo 'Error occured: ',  $e->getMessage(), "\n";
    }
}

?>