<?php

class trustami_product_api
{
    private $apiKey;
    private $curl;
    private $get_fields;
    private $post_fields;
    private $sending_file;

    public function __construct($apiKey)
    {
        $this->curl = curl_init();
        $this->apiKey = $apiKey;
        $this->post_fields = array();
        $this->get_fields = array();
        $this->sending_file = FALSE;

        curl_setopt($this->curl,CURLOPT_HEADER, 0);
        curl_setopt($this->curl,CURLOPT_FRESH_CONNECT, 1);
        curl_setopt($this->curl,CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($this->curl,CURLOPT_FORBID_REUSE, 1);
        curl_setopt($this->curl,CURLOPT_TIMEOUT, 4);

        curl_setopt($this->curl,CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        curl_setopt($this->curl,CURLOPT_USERPWD, $this->apiKey);
    }

    public function __get($property) {
        if (property_exists($this, $property)) {
            return $this->$property;
        }
    }

    public function __set($property, $value) {
        if (property_exists($this, $property)) {
            $this->$property = $value;
        }

        return $this;
    }

    public function setOption($name,$value)
    {
        curl_setopt($this->curl, $name, $value);
        return $this;
    }

    public function post_multiple_products($post_args){
        $url = "https://api.trustami.com/products/multiple/";
        curl_setopt($this->curl, CURLOPT_POST, 1);
        curl_setopt($this->curl, CURLOPT_URL, $url);
        curl_setopt($this->curl, CURLOPT_POSTFIELDS, http_build_query($post_args));
        $return_data = curl_exec($this->curl);
        $errno = curl_errno($this->curl);
        $error = curl_error($this->curl);
        if($errno)
        {
            curl_close ($this->curl);
            trigger_error($error);
        }
        curl_close ($this->curl);
        return $return_data;
    }

    public function reviewCountToString( $number, $returnMin=false, $returnRanks=false ){
        if( !is_int( $number ) && !is_float( $number ) ) return 0;
        
        if (isset($returnRanks)){
            foreach ( $returnRanks as $nr => $range ){
                if ( $number < $range->max ) {
                    return $range->output;
                }
            }
        }
        return 0;
    }

    public function get_curl_version(){
        return curl_version();
    }
}